pcl::poisson::Octree< Degree > Class Template Reference

`#include <pcl/surface/3rdparty/poisson4/multi_grid_octree_data.h>`

## Public Member Functions

| Octree (void)
void | setBSplineData (int maxDepth, Real normalSmooth=-1, bool reflectBoundary=false)
void | finalize (void)
void | RefineBoundary (int subdivisionDepth)
Real * | GetWeightGrid (int &res, int depth=-1)
Real * | GetSolutionGrid (int &res, float isoValue=0.f, int depth=-1)
template<typename PointNT >
int | setTree (boost::shared_ptr< const pcl::PointCloud< PointNT > > input_, int maxDepth, int minDepth, int kernelDepth, Real samplesPerNode, Real scaleFactor, Point3D< Real > &center, Real &scale, int useConfidence, Real constraintWeight, bool adaptiveWeights)
void | SetLaplacianConstraints (void)
void | ClipTree (void)
int | LaplacianMatrixIteration (int subdivideDepth, bool showResidual, int minIters, double accuracy)
Real | GetIsoValue (void)
void | GetMCIsoTriangles (Real isoValue, int subdivideDepth, pcl::poisson::CoredMeshData *mesh, int fullDepthIso=0, int nonLinearFit=1, bool addBarycenter=false, bool polygonMesh=false)

## Static Public Member Functions

static double | MemoryUsage (void)

## Public Attributes

int | threads
std::vector< pcl::poisson::Point3D< Real > > * | normals
Real | postNormalSmooth
TreeOctNode | tree
pcl::poisson::BSplineData< Degree, BSplineDataReal > | fData

## Static Public Attributes

static double | maxMemoryUsage =0

## Detailed Description

### template<int Degree>
class pcl::poisson::Octree< Degree >

Definition at line 195 of file multi_grid_octree_data.h.

## Constructor & Destructor Documentation

template<int Degree>

pcl::poisson::Octree< Degree >::Octree | ( | void |  | ) |

Definition at line 507 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::centerAndWidth(), pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::initChildren(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::TreeNodeData::normalIndex, and pcl::poisson::OctNode< NodeData, Real >::parent.

## Member Function Documentation

template<int Degree>

void pcl::poisson::Octree< Degree >::ClipTree | ( | void |  | ) |

Definition at line 2084 of file multi_grid_octree_data.hpp.

References pcl::poisson::EPSILON, and pcl::poisson::OctNode< NodeData, Real >::nextNode().

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

void pcl::poisson::Octree< Degree >::finalize | ( | void |  | ) |

Definition at line 969 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::TreeNodeData::constraint, pcl::poisson::OctNode< NodeData, Real >::d, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::BSplineData< Degree, Real >::Index(), pcl::poisson::MatrixEntry< T >::N, pcl::poisson::OctNode< NodeData, Real >::Neighbors5::neighbors, pcl::poisson::OctNode< NodeData, Real >::NeighborKey5::neighbors, pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::OctNode< NodeData, Real >::off, pcl::poisson::OctNode< NodeData, Real >::parent, pcl::poisson::TreeNodeData::pointIndex, and pcl::poisson::MatrixEntry< T >::Value.

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

Real pcl::poisson::Octree< Degree >::GetIsoValue | ( | void |  | ) |

Definition at line 2770 of file multi_grid_octree_data.hpp.

References pcl::poisson::CoredMeshData::addOutOfCorePoint(), pcl::poisson::CoredMeshData::addPolygon(), pcl::poisson::OctNode< NodeData, Real >::centerAndWidth(), pcl::poisson::TreeNodeData::centerWeightContribution, pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::Polynomial< Degree >::coefficients, pcl::poisson::OctNode< NodeData, Real >::d, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::RootInfo::edgeIndex, pcl::poisson::OctNode< NodeData, Real >::edgeNeighbor(), pcl::poisson::EPSILON, pcl::poisson::OctNode< NodeData, Real >::faceNeighbor(), pcl::poisson::Polynomial< Degree >::getSolutions(), pcl::poisson::CoredPointIndex::inCore, pcl::poisson::CoredMeshData::inCorePoints, pcl::poisson::CoredPointIndex::index, pcl::poisson::RootInfo::key, pcl::poisson::TreeNodeData::mcIndex, pcl::poisson::OctNode< NodeData, Real >::nextBranch(), pcl::poisson::OctNode< NodeData, Real >::nextLeaf(), pcl::poisson::RootInfo::node, pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::OctNode< NodeData, Real >::parent, and pcl::poisson::OctNode< NodeData, Real >::processNodeFaces().

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

void pcl::poisson::Octree< Degree >::GetMCIsoTriangles | ( | Real | isoValue,
|  | int | subdivideDepth,
|  | pcl::poisson::CoredMeshData * | mesh,
|  | int | fullDepthIso = `0`,
|  | int | nonLinearFit = `1`,
|  | bool | addBarycenter = `false`,
|  | bool | polygonMesh = `false`
| ) |  |

Definition at line 2407 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::OctNode< NodeData, Real >::d, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::TreeNodeData::mcIndex, pcl::poisson::OctNode< NodeData, Real >::ConstNeighbors3::neighbors, pcl::poisson::OctNode< NodeData, Real >::ConstNeighborKey3::neighbors, pcl::poisson::OctNode< NodeData, Real >::ConstNeighborKey5::neighbors, pcl::poisson::OctNode< NodeData, Real >::nextLeaf(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::OctNode< NodeData, Real >::off, pcl::poisson::CoredMeshData::outOfCorePointCount(), pcl::poisson::OctNode< NodeData, Real >::parent, and pcl::poisson::TreeNodeData::solution.

template<int Degree>

Real * pcl::poisson::Octree< Degree >::GetSolutionGrid | ( | int & | res,
|  | float | isoValue = `0.f`,
|  | int | depth = `-1`
| ) |  |

Definition at line 3752 of file multi_grid_octree_data.hpp.

References pcl::poisson::BSplineData< Degree, Real >::functionCount, pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::BSplineData< Degree, Real >::set(), pcl::poisson::BSplineData< Degree, Real >::setSampleSpan(), pcl::poisson::BSplineData< Degree, Real >::setValueTables(), pcl::poisson::BSplineData< Degree, Real >::VALUE_FLAG, and pcl::poisson::BSplineData< Degree, Real >::valueTables.

template<int Degree>

Real * pcl::poisson::Octree< Degree >::GetWeightGrid | ( | int & | res,
|  | int | depth = `-1`
| ) |  |

Definition at line 3796 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::nextNode().

template<int Degree>

int pcl::poisson::Octree< Degree >::LaplacianMatrixIteration | ( | int | subdivideDepth,
|  | bool | showResidual,
|  | int | minIters,
|  | double | accuracy
| ) |  |

Definition at line 1865 of file multi_grid_octree_data.hpp.

References pcl::B, pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::TreeNodeData::constraint, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::SparseMatrix< T >::Entries(), pcl::poisson::OctNode< NodeData, Real >::nextBranch(), pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::SortedTreeNodes::nodeCount, pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::Vector< T >::Norm(), pcl::poisson::TreeNodeData::normalIndex, pcl::poisson::OctNode< NodeData, Real >::parent, pcl::poisson::Vector< T >::Resize(), pcl::poisson::SparseMatrix< T >::Resize(), pcl::poisson::MapReduceVector< T2 >::resize(), pcl::poisson::ROUND_EPS, pcl::poisson::SparseMatrix< T >::rows, pcl::poisson::SparseMatrix< T >::rowSizes, pcl::poisson::SparseMatrix< T >::SetRowSize(), pcl::poisson::TreeNodeData::solution, and pcl::poisson::SortedTreeNodes::treeNodes.

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

double pcl::poisson::Octree< Degree >::MemoryUsage | ( | void |  | ) |

static

Definition at line 500 of file multi_grid_octree_data.hpp.

template<int Degree>

void pcl::poisson::Octree< Degree >::RefineBoundary | ( | int | subdivisionDepth | ) |

Definition at line 2340 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::nextLeaf().

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

void pcl::poisson::Octree< Degree >::setBSplineData | ( | int | maxDepth,
|  | Real | normalSmooth = `-1`,
|  | bool | reflectBoundary = `false`
| ) |  |

Definition at line 960 of file multi_grid_octree_data.hpp.

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

void pcl::poisson::Octree< Degree >::SetLaplacianConstraints | ( | void |  | ) |

Definition at line 2097 of file multi_grid_octree_data.hpp.

References pcl::poisson::TreeNodeData::centerWeightContribution, pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::TreeNodeData::constraint, pcl::poisson::OctNode< NodeData, Real >::depth(), pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::OctNode< NodeData, Real >::initChildren(), pcl::poisson::RootInfo::key, pcl::poisson::Length(), pcl::poisson::TreeNodeData::mcIndex, pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::nodeIndex, pcl::poisson::TreeNodeData::normalIndex, and pcl::poisson::OctNode< NodeData, Real >::parent.

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>
template<typename PointNT >

int pcl::poisson::Octree< Degree >::setTree | ( | boost::shared_ptr< const pcl::PointCloud< PointNT > > | input_,
|  | int | maxDepth,
|  | int | minDepth,
|  | int | kernelDepth,
|  | Real | samplesPerNode,
|  | Real | scaleFactor,
|  | Point3D< Real > & | center,
|  | Real & | scale,
|  | int | useConfidence,
|  | Real | constraintWeight,
|  | bool | adaptiveWeights
| ) |  |

Definition at line 742 of file multi_grid_octree_data.hpp.

References pcl::poisson::OctNode< NodeData, Real >::children, pcl::poisson::OctNode< NodeData, Real >::depthAndOffset(), pcl::poisson::OctNode< NodeData, Real >::initChildren(), pcl::poisson::Length(), pcl::poisson::OctNode< NodeData, Real >::nextNode(), pcl::poisson::OctNode< NodeData, Real >::nodeData, pcl::poisson::TreeNodeData::normalIndex, pcl::poisson::TreeNodeData::pointIndex, and pcl::poisson::OctNode< NodeData, Real >::setFullDepth().

Referenced by pcl::Poisson< PointNT >::~Poisson().

## Member Data Documentation

template<int Degree>

pcl::poisson::BSplineData<Degree,BSplineDataReal> pcl::poisson::Octree< Degree >::fData

Definition at line 341 of file multi_grid_octree_data.h.

template<int Degree>

double pcl::poisson::Octree< Degree >::maxMemoryUsage =0

static

Definition at line 336 of file multi_grid_octree_data.h.

Referenced by pcl::Poisson< PointNT >::~Poisson().

template<int Degree>

std::vector< pcl::poisson::Point3D<Real> >* pcl::poisson::Octree< Degree >::normals

Definition at line 338 of file multi_grid_octree_data.h.

template<int Degree>

Real pcl::poisson::Octree< Degree >::postNormalSmooth

Definition at line 339 of file multi_grid_octree_data.h.

template<int Degree>

int pcl::poisson::Octree< Degree >::threads

Definition at line 335 of file multi_grid_octree_data.h.

template<int Degree>

TreeOctNode pcl::poisson::Octree< Degree >::tree

Definition at line 340 of file multi_grid_octree_data.h.

Referenced by pcl::Poisson< PointNT >::~Poisson().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/poisson4/multi_grid_octree_data.h
- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/3rdparty/poisson4/multi_grid_octree_data.hpp